/*
 * ScaleBoxAction.hpp
 *
 *  Created on: May 8, 2010
 *      Author: heber
 */

#ifndef SCALEBOXACTION_HPP_
#define SCALEBOXACTION_HPP_

#include "Actions/Action.hpp"
#include "LinearAlgebra/Vector.hpp"

void WorldScaleBox(Vector &Scaler);

class WorldScaleBoxAction : public Action {
  friend void WorldScaleBox(Vector &Scaler);

public:
  WorldScaleBoxAction();
  virtual ~WorldScaleBoxAction();

  bool canUndo();
  bool shouldUndo();

  virtual const std::string getName();
protected:
  virtual Dialog * fillDialog(Dialog *dialog);
private:
  virtual void getParametersfromValueStorage();
  virtual Action::state_ptr performCall();
  virtual Action::state_ptr performUndo(Action::state_ptr);
  virtual Action::state_ptr performRedo(Action::state_ptr);

  static const char NAME[];
};

#endif /* SCALEBOXACTION_HPP_ */
